<script>
import { started_state } from '@/plugins/store.js'
import SvelteMarkdown from 'svelte-markdown'
import { splitIntoDigits } from '@/plugins/utils.js';
import Digit from '@/components/digit.svelte';
import { onDestroy } from 'svelte';
export let streamer;
import { team_indicators, team_bg_colors } from '@/plugins/config.js';
let backend = import.meta.env.VITE_BACKEND;

// streamer.data is a store
let d = streamer.data;

let team_color = team_bg_colors[streamer.team_id];

// Subscribe to d and log the value
let unsubscribe = d.subscribe(value => {
    //console.log("t:",streamer.twitch_id, value);
});

// Unsubscribe when the component is destroyed
onDestroy(() => {
    unsubscribe();
});
</script>
    
<style> 

    .colorful-shadow {
        max-width: 85%;
        height: auto;
        position: absolute;
        filter: blur(20px) contrast(1);
    }

    .streamer-picture {
        z-index: 1;
    }
    
    .card-title {
        z-index: 1;
    }

    .team-indicator::after{
        content: var(--team-indicator);
        position: absolute;
        bottom: 0;
        right: 0;
        margin-bottom: 0.75rem;
        margin-right: 1rem;
        z-index: 1;
        color: rgba(51, 51, 51, 0.629);
        font-size: larger;
    }

</style>

<div class="card lg:w-96 w-72 {team_color} shadow-xl pt-5" style="--team-indicator: '{team_indicators[streamer.team_id]}'">
    <h2 class="card-title place-self-center mb-3">{streamer.name}</h2>
    <figure class="mx-10">
        {#if streamer.image_file}
            <img class="rounded-md streamer-picture" loading="lazy" src="{backend + streamer.image_file}" alt="Streamer Avatar"/>
            <img class="rounded-md colorful-shadow" loading="lazy" src="{backend + streamer.image_file}" alt="Streamer Avatar shadow"/>
        {:else}
            <img class="rounded-md streamer-picture" src="person.png" alt="Streamer Avatar"/>
            <img class="rounded-md colorful-shadow" src="person.png" alt="Streamer Avatar"/>
        {/if}
    </figure>
    <div class="card-body rounded-2xl team-indicator">
        <p>
            <SvelteMarkdown source={streamer.description} />
        </p>
        <div class="card-actions justify-center">
            {#if $started_state == 2}
                {#if streamer.il}
                    <div class="indicator">
                        <span class="indicator-item badge badge-secondary bg-red-800 text-white">Live !</span> 
                        <a class="btn lg:btn-wide w-52 lg:btn-lg btn-success hover:btn-primary" href="/stream/{streamer.id}">
                            <div class="text-center">
                                <p class="text-white">Viewers :</p>
                                <div class="grid grid-flow-col text-center auto-cols-max justify-center">
                                    {#each splitIntoDigits(streamer.vc, 0) as count}
                                        <div class="flex flex-col text-white font-mono text-2xl mt-2">
                                            <Digit digit={count} />
                                        </div> 
                                    {/each}
                                </div>
                            </div>
                        </a>
                    </div>
                {:else}
                    <a class="btn lg:btn-wide w-52 lg:btn-lg" href="/stream/{streamer.id}">
                        <div class="text-center">
                            <div class="grid grid-flow-col text-center auto-cols-max">
                                <p>Hors-Ligne</p>
                            </div>
                        </div>
                    </a>
                {/if}
            {:else}
                <a class="btn btn-success hover:btn-primary" href="https://twitch.tv/{streamer.twitch_id}">
                    <div class="text-center">
                        <div class="grid grid-flow-col text-center auto-cols-max">
                            <p><i class="fa-brands fa-twitch"></i>t.tv/{streamer.twitch_id}</p>
                        </div>
                    </div>
                </a>
            {/if}
        </div>
    </div>
</div>